Loading...
Searching...
No Matches
BALL::VIEW::AddBackboneModel Class Reference
Visualisation » Model Processors

`#include <BALL/VIEW/MODELS/backboneModel.h>`

Inheritance diagram for BALL::VIEW::AddBackboneModel:

## Classes

struct | ModelPart

## Public Member Functions

| AddBackboneModel ()
| Default Constructor.
| AddBackboneModel (const AddBackboneModel &add_Backbone_model)
| Copy constructor.
virtual | ~AddBackboneModel ()
| Destructor.
virtual void | clear ()
virtual bool | start ()
virtual Processor::Result | operator() (Composite &composite)
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
void | setTubeRadius (float radius)
float | getTubeRadius () const
virtual bool | createGeometricObjects ()
void | setRibbonMode (bool state)
bool | ribbonModeEnabled () const
Public Member Functions inherited from BALL::VIEW::ModelProcessor
| ModelProcessor ()
| ModelProcessor (const ModelProcessor &model_processor)
virtual | ~ModelProcessor ()
virtual bool | isValid () const
virtual void | clearComposites ()
GeometricObjectList & | getGeometricObjects ()
| Return the list with the created geometric objects.
const GeometricObjectList & | getGeometricObjects () const
| Return the list with the created geometric objects.
void | setDrawingPrecision (Index precision)
Index | getDrawingPrecision () const
void | setSurfaceDrawingPrecision (float precision)
float | getSurfaceDrawingPrecision () const
Public Member Functions inherited from BALL::UnaryProcessor< Composite >
| UnaryProcessor ()
| UnaryProcessor (const UnaryProcessor &)
virtual | ~UnaryProcessor ()
virtual bool | finish ()
Public Member Functions inherited from BALL::PropertyManager
BALL_INLINE | PropertyManager ()
| Default constructor.
BALL_INLINE | PropertyManager (const PropertyManager &property_manager)
| Copy constructor.
virtual | ~PropertyManager ()
| Destructor.
virtual void | destroy ()
| Clears all properties.
void | set (const PropertyManager &property_manager)
const PropertyManager & | operator= (const PropertyManager &property_manager)
void | get (PropertyManager &property_manager) const
void | swap (PropertyManager &property_manager)
BitVector & | getBitVector ()
const BitVector & | getBitVector () const
| operator BitVector & ()
void | setProperty (Property property)
void | clearProperty (Property property)
void | toggleProperty (Property property)
Size | countProperties () const
const NamedProperty & | getNamedProperty (Position index) const
NamedProperty & | getNamedProperty (Position index)
void | setProperty (const NamedProperty &property)
void | setProperty (const std::string &name)
void | setProperty (const std::string &name, bool value)
void | setProperty (const std::string &name, int value)
void | setProperty (const std::string &name, unsigned int value)
void | setProperty (const std::string &name, float value)
void | setProperty (const std::string &name, double value)
void | setProperty (const std::string &name, const std::string &value)
void | setProperty (const std::string &name, const PersistentObject &value)
const NamedProperty & | getProperty (const std::string &name) const
NamedPropertyIterator | beginNamedProperty ()
NamedPropertyIterator | endNamedProperty ()
void | clearProperty (const std::string &name)
Size | countNamedProperties () const
bool | hasProperty (Property property) const
| Query for an unnamed property.
bool | hasProperty (const std::string &name) const
| Query for a named property.
bool | operator== (const PropertyManager &pm) const
bool | operator!= (const PropertyManager &pm) const
| Inequality operator.
void | write (PersistenceManager &pm) const
| Persistent stream writing.
bool | read (PersistenceManager &pm)
| Persistent stream reading.
bool | isValid () const
void | dump (std::ostream &s=std::cout, Size depth=0) const

## Protected Types

enum | ModelTypes { TUBE , RIBBON , NUCLEIC_ACID }

## Protected Member Functions

virtual void | calculateModelParts (Protein &protein)
virtual bool | collectPositions (vector< Residue * > residues)
virtual void | calculateGuidePoints_ ()
virtual void | assignModelType (ModelPart &part)
virtual void | createModel_ (Position set_pos, Position model_pos)
virtual void | createTube_ (Position set_pos, Position model_pos)
virtual void | createRibbon_ (Position set_pos, Position model_pos)
virtual void | refineGuidePoints_ ()
virtual void | interpolate_ ()
virtual void | refineModelParts_ ()
virtual void | clear_ ()
void | evaluateBSpline (const Vector3 &v1, const Vector3 &v2, const Vector3 &v3, float x, Vector3 &result)
bool | residuesAreConnected_ (Residue &residue1, Residue &residue2)
void | calculateTubePoints_ (Vector3 right, Vector3 dir, vector< Vector3 > &points)
void | calculateRibbonPoints_ (Vector3 xn, Vector3 dir, vector< Vector3 > &points)
void | calculateRibbonEllipse_ (float ribbon_width, float ribbon_height)

## Protected Attributes

float | tube_radius_
Size | interpolation_steps_
Size | number_of_ribbons_
float | ribbon_width_
float | ribbon_height_
bool | care_for_SS_
bool | ribbon_mode_
vector< vector< vector< Vector3 > > > | guide_points_
vector< vector< vector< Vector3 > > > | interpolated_points_
vector< vector< Vector3 > > | backbone_
vector< vector< Vector3 > > | offsets_
vector< vector< ModelPart > > | model_parts_
Protein | dummy_protein_
Chain | dummy_chain_
SecondaryStructure | dummy_ss_
HashSet< Residue * > | residues_to_be_rendered_
Protein * | last_protein_
vector< vector< Index > > | ss_
Size | slides_
Position | middle_slide_
Position | middle_ribbon_
Angle | slides_angle_
Matrix4x4 | temp_matrix_
vector< float > | xs_
vector< float > | ys_
Protected Attributes inherited from BALL::VIEW::ModelProcessor
GeometricObjectList | geometric_objects_
Index | drawing_precision_
float | surface_drawing_precision_

## Additional Inherited Members

Public Types inherited from BALL::UnaryFunctor< ArgumentType, ResultType >
typedef ResultType | result_type
typedef ArgumentType | argument_type
typedef ArgumentType & | argument_reference
typedef const ArgumentType & | const_argument_reference
typedef ArgumentType * | argument_pointer
typedef const ArgumentType * | const_argument_pointer

## Detailed Description

AddBackboneModel class. The class AddBackboneModel is a model processor that creates a backbone model through the CA-atoms of the processed Composite object. For information about the processor concept see Processor in the BALL documentation.

Definition at line 41 of file backboneModel.h.

## Member Enumeration Documentation

## ModelTypes

enum BALL::VIEW::AddBackboneModel::ModelTypes

protected

Enumerator
TUBE |
RIBBON |
NUCLEIC_ACID |

Definition at line 64 of file backboneModel.h.

## Constructor & Destructor Documentation

## AddBackboneModel() [1/2]

BALL::VIEW::AddBackboneModel::AddBackboneModel | ( |  | ) |

Default Constructor.

## AddBackboneModel() [2/2]

BALL::VIEW::AddBackboneModel::AddBackboneModel | ( | const AddBackboneModel & | add_Backbone_model | ) |

Copy constructor.

## ~AddBackboneModel()

virtual BALL::VIEW::AddBackboneModel::~AddBackboneModel | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## assignModelType()

virtual void BALL::VIEW::AddBackboneModel::assignModelType | ( | ModelPart & | part | ) |

protected virtual

Reimplemented in BALL::VIEW::AddCartoonModel.

## calculateGuidePoints_()

virtual void BALL::VIEW::AddBackboneModel::calculateGuidePoints_ | ( |  | ) |

protected virtual

## calculateModelParts()

virtual void BALL::VIEW::AddBackboneModel::calculateModelParts | ( | Protein & | protein | ) |

protected virtual

Reimplemented in BALL::VIEW::AddCartoonModel.

## calculateRibbonEllipse_()

void BALL::VIEW::AddBackboneModel::calculateRibbonEllipse_ | ( | float | ribbon_width,
|  | float | ribbon_height )

inline protected

## calculateRibbonPoints_()

void BALL::VIEW::AddBackboneModel::calculateRibbonPoints_ | ( | Vector3 | xn,
|  | Vector3 | dir,
|  | vector< Vector3 > & | points )

inline protected

## calculateTubePoints_()

void BALL::VIEW::AddBackboneModel::calculateTubePoints_ | ( | Vector3 | right,
|  | Vector3 | dir,
|  | vector< Vector3 > & | points )

inline protected

## clear()

virtual void BALL::VIEW::AddBackboneModel::clear | ( |  | ) |

virtual

Explicit default initialization. Calls ModelProcessor::clear.

Reimplemented from BALL::VIEW::ModelProcessor.

## clear_()

virtual void BALL::VIEW::AddBackboneModel::clear_ | ( |  | ) |

protected virtual

## collectPositions()

virtual bool BALL::VIEW::AddBackboneModel::collectPositions | ( | vector< Residue * > | residues | ) |

protected virtual

## createGeometricObjects()

virtual bool BALL::VIEW::AddBackboneModel::createGeometricObjects | ( |  | ) |

virtual

Method to create geometric objects. This method is called in Representation::update() after all operator() was called for all Composites. To be overloaded in derived classes

Reimplemented from BALL::VIEW::ModelProcessor.

## createModel_()

virtual void BALL::VIEW::AddBackboneModel::createModel_ | ( | Position | set_pos,
|  | Position | model_pos )

protected virtual

Reimplemented in BALL::VIEW::AddCartoonModel.

## createRibbon_()

virtual void BALL::VIEW::AddBackboneModel::createRibbon_ | ( | Position | set_pos,
|  | Position | model_pos )

protected virtual

## createTube_()

virtual void BALL::VIEW::AddBackboneModel::createTube_ | ( | Position | set_pos,
|  | Position | model_pos )

protected virtual

## dump()

virtual void BALL::VIEW::AddBackboneModel::dump | ( | std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

Internal value dump. Dump the current state to the output ostream s with dumping depth depth. Calls ModelProcessor::dump.

Parameters

  s | output stream where to output the state
  depth | the dumping depth

Reimplemented from BALL::VIEW::ModelProcessor.

## evaluateBSpline()

void BALL::VIEW::AddBackboneModel::evaluateBSpline | ( | const Vector3 & | v1,
|  | const Vector3 & | v2,
|  | const Vector3 & | v3,
|  | float | x,
|  | Vector3 & | result )

inline protected

## getTubeRadius()

float BALL::VIEW::AddBackboneModel::getTubeRadius | ( |  | ) | const

inline

Definition at line 115 of file backboneModel.h.

## interpolate_()

virtual void BALL::VIEW::AddBackboneModel::interpolate_ | ( |  | ) |

protected virtual

## operator()()

virtual Processor::Result BALL::VIEW::AddBackboneModel::operator() | ( | Composite & | composite | ) |

virtual

Operator method. This method iterates over each Composite object reachable in the Composite tree. If a Composite is of kind Atom and has the substring CA in its name (this method collects only CA-atoms) than that atom is stored for later processing in the finish method.

Parameters

  composite | the Composite object that will be processed

Reimplemented from BALL::UnaryProcessor< Composite >.

## refineGuidePoints_()

virtual void BALL::VIEW::AddBackboneModel::refineGuidePoints_ | ( |  | ) |

inline protected virtual

Reimplemented in BALL::VIEW::AddCartoonModel.

Definition at line 144 of file backboneModel.h.

## refineModelParts_()

virtual void BALL::VIEW::AddBackboneModel::refineModelParts_ | ( |  | ) |

protected virtual

## residuesAreConnected_()

bool BALL::VIEW::AddBackboneModel::residuesAreConnected_ | ( | Residue & | residue1,
|  | Residue & | residue2 )

inline protected

## ribbonModeEnabled()

bool BALL::VIEW::AddBackboneModel::ribbonModeEnabled | ( |  | ) | const

inline

Definition at line 126 of file backboneModel.h.

## setRibbonMode()

void BALL::VIEW::AddBackboneModel::setRibbonMode | ( | bool | state | ) |

inline

Definition at line 122 of file backboneModel.h.

## setTubeRadius()

void BALL::VIEW::AddBackboneModel::setTubeRadius | ( | float | radius | ) |

inline

Definition at line 111 of file backboneModel.h.

## start()

virtual bool BALL::VIEW::AddBackboneModel::start | ( |  | ) |

virtual

start method

Reimplemented from BALL::UnaryProcessor< Composite >.

## Member Data Documentation

## backbone_

vector<vector<Vector3> > BALL::VIEW::AddBackboneModel::backbone_

protected

Definition at line 173 of file backboneModel.h.

## care_for_SS_

bool BALL::VIEW::AddBackboneModel::care_for_SS_

protected

Definition at line 168 of file backboneModel.h.

## dummy_chain_

Chain BALL::VIEW::AddBackboneModel::dummy_chain_

protected

Definition at line 178 of file backboneModel.h.

## dummy_protein_

Protein BALL::VIEW::AddBackboneModel::dummy_protein_

protected

Definition at line 177 of file backboneModel.h.

## dummy_ss_

SecondaryStructure BALL::VIEW::AddBackboneModel::dummy_ss_

protected

Definition at line 179 of file backboneModel.h.

## guide_points_

vector<vector<vector<Vector3> > > BALL::VIEW::AddBackboneModel::guide_points_

protected

Definition at line 171 of file backboneModel.h.

## interpolated_points_

vector<vector<vector<Vector3> > > BALL::VIEW::AddBackboneModel::interpolated_points_

protected

Definition at line 172 of file backboneModel.h.

## interpolation_steps_

Size BALL::VIEW::AddBackboneModel::interpolation_steps_

protected

Definition at line 163 of file backboneModel.h.

## last_protein_

Protein* BALL::VIEW::AddBackboneModel::last_protein_

protected

Definition at line 181 of file backboneModel.h.

## middle_ribbon_

Position BALL::VIEW::AddBackboneModel::middle_ribbon_

protected

Definition at line 186 of file backboneModel.h.

## middle_slide_

Position BALL::VIEW::AddBackboneModel::middle_slide_

protected

Definition at line 185 of file backboneModel.h.

## model_parts_

vector<vector<ModelPart> > BALL::VIEW::AddBackboneModel::model_parts_

protected

Definition at line 175 of file backboneModel.h.

## number_of_ribbons_

Size BALL::VIEW::AddBackboneModel::number_of_ribbons_

protected

Definition at line 165 of file backboneModel.h.

## offsets_

vector<vector<Vector3> > BALL::VIEW::AddBackboneModel::offsets_

protected

Definition at line 174 of file backboneModel.h.

## residues_to_be_rendered_

HashSet<Residue*> BALL::VIEW::AddBackboneModel::residues_to_be_rendered_

protected

Definition at line 180 of file backboneModel.h.

## ribbon_height_

float BALL::VIEW::AddBackboneModel::ribbon_height_

protected

Definition at line 167 of file backboneModel.h.

## ribbon_mode_

bool BALL::VIEW::AddBackboneModel::ribbon_mode_

protected

Definition at line 169 of file backboneModel.h.

## ribbon_width_

float BALL::VIEW::AddBackboneModel::ribbon_width_

protected

Definition at line 166 of file backboneModel.h.

## slides_

Size BALL::VIEW::AddBackboneModel::slides_

protected

Definition at line 184 of file backboneModel.h.

## slides_angle_

Angle BALL::VIEW::AddBackboneModel::slides_angle_

protected

Definition at line 187 of file backboneModel.h.

## ss_

vector<vector<Index> > BALL::VIEW::AddBackboneModel::ss_

protected

Definition at line 182 of file backboneModel.h.

## temp_matrix_

Matrix4x4 BALL::VIEW::AddBackboneModel::temp_matrix_

protected

Definition at line 188 of file backboneModel.h.

## tube_radius_

float BALL::VIEW::AddBackboneModel::tube_radius_

protected

Definition at line 160 of file backboneModel.h.

## xs_

vector<float> BALL::VIEW::AddBackboneModel::xs_

protected

Definition at line 189 of file backboneModel.h.

## ys_

vector<float> BALL::VIEW::AddBackboneModel::ys_

protected

Definition at line 189 of file backboneModel.h.